program ahorcado;

 {*************************************************************}
 {*************************************************************}
 {***  autor.- Jos C. Remiro                           *******}
 {***  Fecha ultima versin.- 15 de abril de 1996       *******}
 {***  Versin.- 1.2                                    *******}
 {***  Nombre del archivo: ahorcado.pas                 *******}
 {***     Realizado para Solo Programadores             *******}
 {*************************************************************}
 {*************************************************************}

uses
 graph, dos, crt;
const
 num_letras = 27;
 num_elem_filas = 9;
 separacion_fila = 30;
 tamanyo_letra = 25;
 pal_advx = 50;
 pal_advy = 260;
 mensaje_x = 70;
 mensaje_y = 400;
 color_fondo = 1;
 color_actual = 12;
 color_mensaje = 15;
 color_sel = 3;
 color_nosel = 11;
 color_ahorcado = 7;
 color_marco = 5;
 tecla_escape = 27;
 tecla_enter = 13;
type
 rango = 1..100;
 letras = record
            let: char;
            seleccionada: boolean;
          end;
 abcda = array [1..num_letras] of letras;
 lista_ab = string[12];
 cadena = record
           palabra: lista_ab;
           aciertos: array[1..12] of boolean;
          end;
 archivo = file of lista_ab;
var
 pal_adivinar: cadena;
 lista_letras: abcda;
 iniciox, inicioy: integer;
 numero_errores: integer;
 arch_palabras: archivo;
 tray_archivo: string;
 codigo_tecla: integer;
 i: integer;

{************************************************************}

function existe_archivo (nom_arch: string): boolean;

 {comprueba que el nombre de archivo pasado como par metro
  existe}

 var
  f: file;
 begin
  {$i-}
  assign(f, nom_arch);
  filemode:= 0;
  reset(f);
  close(f);
  {$i+}
  existe_archivo:= (ioresult = 0) and (nom_arch <> '');
 end;

{************************************************************}

procedure obten_palabra (var f: archivo ; var pal: lista_ab);

 {asigna una palabra almacenada en el archivo f, al parmetro pal
  seleccionandola de forma aleatoria}

 var
  num_reg: integer;
  posicion: integer;
  p: lista_ab;
 begin
  num_reg:= filesize (f);
  randomize;
  posicion:= random (num_reg);
  seek(arch_palabras, posicion);
  read(arch_palabras, pal);
 end;

 {************************************************************}

procedure ocultar_cursor;

{elimina el cursor de la pantalla utilizando la interrupcin 16,
 utiliza la unit dos}

 var
  regs: registers;
 begin
  with regs
      do
       begin
        ax:= $0100;
        cx:= $2000;
       end;
  intr(16,regs);
 end;
 {************************************************************}

procedure modo_grafico;

 {comprueba el tipo de tarjeta instalada en el ordenador e inicializa
  el modo gr fico. este programa solo est  preparado para trabajar con
  tarjeta vga}

 var
  driver_grafico: integer;
  modo_grafico: integer;
  codigo_error: integer;
 begin
  driver_grafico:= detect;
  initgraph(driver_grafico, modo_grafico, 'd:\tp\bgi');
  codigo_error:= graphresult;
  if codigo_error <> grok
    then
     begin
      writeln('error de gr ficos: ', grapherrormsg(codigo_error));
      writeln('programa abortado');
      halt(1);
     end;
 end;

 {************************************************************}

procedure mensaje_utilizacion (col: integer);

 begin
  settextstyle(triplexfont, horizdir, 1);
  setcolor(col);
  moveto (170, 382);
  outtext ('CON LAS TECLAS DE CURSOR E INTRO ');
  moveto (180, 416);
  outtext ('SELECCIONA UNA DE LAS LETRAS');
  settextstyle(defaultfont, horizdir, 2);
 end;

 {*************************************************************}

procedure inicia_lista_letras (var l: abcda);

{inicializa el array que contiene las letras que el usuario podr
seleccionar. asigna el valor false al campo seleccionada indicando
que an no se ha seleccionado dicha letra}

 var
  i: integer;
  codigo: integer;
 begin
  codigo:= 64;
  for i:= 1 to 14
     do
      begin
       l[i].let:= chr(i+codigo);
       l[i].seleccionada:= false;
      end;
  l[15].let:= '';
  codigo:= codigo - 1;
  for i:= 16 to num_letras
     do
      begin
       l[i].let:= chr(i+codigo);
       l[i].seleccionada:= false;
      end;
 end;

{************************************************************}

procedure calcula_pos_letra (ord_letra: integer; var coorx, coory: integer);

{devuelve las coordenadas donde est  situado la letra cuya
 posicion en el array donde se encuentran almacenadas es ord_letras}

 var
  resto, cociente: integer;
 begin
  resto:= ord_letra mod num_elem_filas;
  cociente:= ord_letra div num_elem_filas;
  if resto = 0
    then
     begin
      resto:= 8;
      cociente:= cociente - 1
     end
    else
     resto:= resto - 1;
  coorx:= iniciox + tamanyo_letra * resto;
  coory:= inicioy + separacion_fila * cociente;
 end;

 {************************************************************}

procedure iluminar_letra (codigo_tecla: integer; var orden_letra: integer);

{cambia el color de los caracteres seleccionados en la pantalla
 dependiendo del cdigo ascii incluido en codigo_tecla y de la
 posicin donde se encuentra almacenada la letra. los cdigos de
 tecla admisibles son las teclas de cursor (72, 75, 77, 80)}

 var
  nv_orden_letra: integer;
  posicionx_carac, posiciony_carac: integer;

         {****************************}

 procedure mover_arriba (var ord_let: integer);
  begin
   if ord_let > 9
     then
      ord_let:= ord_let - 9
     else
      ord_let:= ord_let + 18;
  end;
         {****************************}

 procedure mover_abajo (var ord_let: integer);
  begin
   if ord_let > 18
     then
      ord_let:= ord_let - 18
     else
      ord_let:= ord_let + 9;
  end;

         {*****************************}

 procedure mover_derecha (var ord_let: integer);
  begin
   if ord_let = 27
     then
      ord_let:= 1
     else
      ord_let:= ord_let + 1;
  end;

         {******************************}

 procedure mover_izqda (var ord_let: integer);
  begin
   if ord_let = 1
     then
      ord_let:= 27
     else
      ord_let:= ord_let - 1;
  end;

 begin {de iluminar letra}
  nv_orden_letra:= orden_letra;
  case codigo_tecla of
      72: mover_arriba  (nv_orden_letra);
      75: mover_izqda   (nv_orden_letra);
      77: mover_derecha (nv_orden_letra);
      80: mover_abajo   (nv_orden_letra);
  end;
  calcula_pos_letra (orden_letra, posicionx_carac, posiciony_carac);
  moveto (posicionx_carac, posiciony_carac);
  if lista_letras [orden_letra].seleccionada
     then
      setcolor(color_sel)
     else
      setcolor(color_nosel);
  outtext(lista_letras[orden_letra].let);
  calcula_pos_letra (nv_orden_letra, posicionx_carac, posiciony_carac);
  setcolor(color_actual);
  moveto (posicionx_carac, posiciony_carac);
  outtext(lista_letras[nv_orden_letra].let);
  orden_letra:= nv_orden_letra;
 end;{de iluminar_letra}

 {************************************************************}

procedure buscar_caracter (ord_letra: integer; ll: abcda;
                          var pal: cadena; var acertado: boolean);

 {busca en palabra la letra indicada por ord_letra, devolviendo
  en acertado el valor true si se encuentra o falso en caso
  contrario}

 var
  i: integer;
  coorx: integer;
 begin
  acertado:= false;
  for i:= 1 to length(pal.palabra)
     do
      if upcase(pal.palabra[i]) = ll[ord_letra].let
        then
         begin
          acertado:= true;
          pal.aciertos[i]:= true;
          coorx:= pal_advx + tamanyo_letra * (i-1);
          setcolor (color_fondo);
          moveto(coorx, pal_advy);
          outtext('_');
          moveto(coorx,pal_advy);
          setcolor (color_nosel);
          outtext(upcase(pal.palabra[i]));
         end;
 end;

 {************************************************************}

procedure sonido_error;

 {emite un sonido cuando se selecciona una tecla seleccionada
  anteriormente}

 var
  i: integer;
 begin
  for i:= 1 to 2
     do
      begin
       sound(75);
       delay(150);
       nosound;
       delay(50);
      end;
  end;

  {************************************************************}

procedure sonido_acierto;

 var
  i, j: integer;
 begin
  j:= 1;
  for i:= 1 to 15
    do
     begin
      sound (150 + 20*j);
      delay (25*j);
      if j > 7
        then
         j:= j - 1
        else
         j:= j + 1;
      nosound;
      delay( 100 - 5*j);
     end;
  sound(200);
  delay(300);
  nosound;
 end;

  {***************************************************************}

procedure dibuja_ahorcado (num_errores: integer);

 {dependiendo del valor de num_erres se dibuja en pantalla
  la parte correspondiente del mueco}

           {**************************}

  procedure dibuja_horca;
   begin
    setfillstyle (1,color_ahorcado);
    bar (400,45,500,55);
    bar (400,55,410,270);
    bar (400, 270, 550 ,290);
   end;

           {**************************}

  procedure dibuja_cabeza;
   begin
    setfillstyle(1,color_ahorcado);
    setcolor(color_ahorcado);
    fillellipse(500,75,15,15);
   end;

          {**************************}

  procedure dibuja_cuerpo;
   begin
    setfillstyle(1,color_ahorcado);
    bar (490,92,510,155);
   end;

           {**************************}

  procedure dibuja_brazo_dcho;
   begin
    setfillstyle(1,color_ahorcado);
    setcolor (color_ahorcado);
    bar (510,97, 555, 107);
    fillellipse (562,102, 5, 5);
   end;

          {**************************}

  procedure dibuja_brazo_izd;
   begin
    setfillstyle(1, color_ahorcado);
    setcolor (color_ahorcado);
    bar (445,97,490,107);
    fillellipse (438 ,102 , 5, 5)
   end;

          {**************************}

  procedure dibuja_pierna_dcha;
   var
    pierna_dcha: array[0..4] of pointtype;
   begin
    pierna_dcha[0].x:= 490;
    pierna_dcha[0].y:= 160;
    pierna_dcha[1].x:= 500;
    pierna_dcha[1].y:= 160;
    pierna_dcha[2].x:= 480;
    pierna_dcha[2].y:= 235;
    pierna_dcha[3].x:= 470;
    pierna_dcha[3].y:= 235;
    pierna_dcha[4].x:= 490;
    pierna_dcha[4].y:= 160;
    setfillstyle (1,color_ahorcado);
    setcolor (color_ahorcado);
    drawpoly(5, pierna_dcha);
    fillpoly(5, pierna_dcha);
    fillellipse(465, 242, 12, 4);
   end;

            {**************************}

  procedure dibuja_pierna_izd;
   var
    pierna_izd: array[0..4] of pointtype;

             {**************************}

    procedure sonido_fin_ahorcado;
     var
      i: integer;
     begin
      for i:= 1 to 6
        do
         begin
          sound (900 div i);
          delay (i*100);
          nosound;
         end;
     end;
   begin
    pierna_izd[0].x:= 500;
    pierna_izd[0].y:= 160;
    pierna_izd[1].x:= 510;
    pierna_izd[1].y:= 160;
    pierna_izd[2].x:= 530;
    pierna_izd[2].y:= 235;
    pierna_izd[3].x:= 520;
    pierna_izd[3].y:= 235;
    pierna_izd[4].x:= 500;
    pierna_izd[4].y:= 160;
    setfillstyle (1,color_ahorcado);
    setcolor(color_ahorcado);
    drawpoly(5, pierna_izd);
    fillpoly(5, pierna_izd);
    fillellipse (535, 242, 12, 4);

    sonido_fin_ahorcado;
   end;

 begin {de dibuja_ahorcado}

  case  num_errores of
     1: dibuja_horca;
     2: dibuja_cabeza;
     3: dibuja_cuerpo;
     4: dibuja_brazo_dcho;
     5: dibuja_brazo_izd;
     6: dibuja_pierna_dcha;
     7: dibuja_pierna_izd;
  end;
 end; {de dibuja ahorcado}

 {*************************************************************}

 procedure mensaje_felicitacion;
  begin
   mensaje_utilizacion(color_fondo);
   setcolor(color_mensaje);
   moveto(125, 382);
   settextstyle(triplexfont, horizdir, 1);
   outtext('ENHORABUENA. HAS ADIVINADO LA PALABRA');
   sonido_acierto;
   settextstyle(defaultfont, horizdir,2);
  end;

{****************************************************************}

 procedure mensaje_pesame;
 var
  i: integer;
  coorx: integer;
 begin
  settextstyle(triplexfont, horizdir, 1);
  moveto(170, 382);
  mensaje_utilizacion (color_fondo);
  setcolor(color_mensaje);
  moveto(170, 382);
  settextstyle (triplexfont, horizdir, 1);
  outtext('HAS UTILIZADO EL ULTIMO INTENTO');
  settextstyle(defaultfont, horizdir, 2);
  for i:= 1 to length(pal_adivinar.palabra)
     do
      if not pal_adivinar.aciertos[i]
        then
         begin
          coorx:= pal_advx + tamanyo_letra * (i-1);
          moveto(coorx, pal_advy);
          setcolor(color_fondo);
          outtext('_');
          moveto(coorx, pal_advy);
          setcolor(color_actual);
          outtext(upcase(pal_adivinar.palabra[i]))
         end;
 end;

{****************************************************************}

procedure seleccion_teclas (var tecla_pulsada: integer;
                            var ad_pal: cadena);
 {en este procedimiento se realizan la mayoria de las acciones
  de este programa. devuelve el cdigo de la tecla pulsada
  para finalizar el programa en caso de ser el cdigo de la
  tecla escape}

 var
  teclas_movimientos: set of rango;
  teclas_validas: set of rango;
  {tecla_pulsada: integer;}
  orden_letra: integer;
  ch: char;
  acertado: boolean;
  final_palabra: boolean;

            {******************************}

  procedure comprobar_final (b: boolean; var f_palabra: boolean;
                             var n_err: integer; ad_p: cadena);

   {este procedimiento comprueba si el par metro b es verdadero,
    esto significa que se ha encontrado al menos una ocurrencia
    en la palabra a adivinar, comprobando si ya ha sido acertada
    y devolviendo en este caso verdadero en el par metro f_palabra
    si no se ha acertado una letra perteneciente a la palabra dicho
    par metro se pone a false y se contabiliza un nuevo error en el
    par metro n_err. se aprovecha tambin para comprobar si el
    usuario ha acabado todas las oportunidades}

   var
    i: integer;
   begin
    f_palabra:= true;
    if b
      then
       begin
        for i:= 1 to length(ad_p.palabra)
           do
            f_palabra:= (f_palabra and ad_p.aciertos[i]);
        if f_palabra
          then
           mensaje_felicitacion;
       end
      else
       begin
        n_err:= n_err + 1;
        dibuja_ahorcado (n_err);
        if n_err = 7
          then
           begin
            f_palabra:= true;
            mensaje_pesame
           end
          else
           f_palabra:= false
       end
   end;

            {***************************}

   function devuelve_tecla (b: boolean): integer;

   {procedimiento que acepta una tecla y devuelve su cdigo
    ascii. tambin devuelve un mensaje si se debe comenzar
    con una nueva palabra}

    var
     regs: registers;
     ch: char;
     aux: integer;
    begin
     if b  {se ha terminado la jugada con la palabra actual}
       then
        begin
         settextstyle(triplexfont, horizdir, 1);
         setcolor (color_mensaje);
         moveto(110,416);
         outtext('PULSA UNA TECLA PARA CONTINUAR (ESC = FIN)');
         settextstyle (defaultfont, horizdir, 2);
         delay (1000);
         regs.ah:= $01;
         intr($16, regs);
         if (regs.flags and $0040) = 0
           then
            repeat
             regs.ah:= 0;
             intr($16, regs);
             regs.ah:= $01;
             intr($16, regs);
            until (regs.flags and $0040) <> 0;
         ch:= readkey;
         devuelve_tecla:= ord(ch);
        end
       else
        begin
         repeat
          ch:=readkey;
          aux:= ord(ch);
         until aux in teclas_validas;
         devuelve_tecla:= ord(ch);
        end;
     end;

 begin {del procedimiento seleccion_teclas}
  teclas_movimientos:= [72,75,77,80];
  teclas_validas:= teclas_movimientos + [13, 27];
  orden_letra:= 27;
  tecla_pulsada:= 77;
  final_palabra:= false;
  while (tecla_pulsada <> tecla_escape) and ( not final_palabra)
      do
        begin
         if tecla_pulsada in teclas_movimientos
           then
            iluminar_letra (tecla_pulsada, orden_letra)
           else
            if tecla_pulsada = tecla_enter
               then
                 if lista_letras [orden_letra].seleccionada
                   then
                    sonido_error
                   else
                    begin
                     lista_letras[orden_letra].seleccionada:= true;
                     buscar_caracter (orden_letra,lista_letras, ad_pal, acertado);
                     comprobar_final (acertado, final_palabra, numero_errores, ad_pal);
                    end;
         tecla_pulsada:= devuelve_tecla (final_palabra);
        end;
 end; {del procedimiento seleccion_teclas}

 {**************************************************************}

procedure inicio;

 {en este procedimiento se realizan todas las inicializaciones
  necesarias para comenzar a jugar con una nueva palabra}

var
 i: integer;
 posicionx_carac, posiciony_carac: integer;
begin
 numero_errores:= 0;
 setbkcolor(color_fondo);
 settextstyle (defaultfont, horizdir, 2);
 iniciox:= 50;
 inicioy:= 70;
 setcolor(color_marco);
 setlinestyle(Userbitln, $F99F,Thickwidth); {establece el estilo de lnea}
 for i:= 0 to 5 {dibujo del marco de la pantalla}
    do
     rectangle(2 * i,2 * i, getmaxx -2*i, getmaxy -2*i);
 rectangle (iniciox - 10, inicioy - 10, iniciox + 9 * 25 , inicioy + 3*30 );
 setlinestyle (solidln,0,normwidth);
 setcolor(color_nosel);
 for i:= 1 to 27
   do
    begin
     calcula_pos_letra (i, posicionx_carac, posiciony_carac);
     moveto (posicionx_carac, posiciony_carac);
     setcolor(color_nosel);
     outtext(lista_letras[i].let);
    end;
 setcolor(color_sel);
 for i:= 1 to length(pal_adivinar.palabra)
    do
     begin
      posicionx_carac:= pal_advx + (i-1) * tamanyo_letra;
      moveto(posicionx_carac, pal_advy);
      outtext('_');
     end;
 setcolor(color_mensaje);
 setlinestyle (userbitln, $AAAA, thickwidth);
 rectangle (50,370,600, 450);
 setlinestyle (solidln, 0, normwidth);
 mensaje_utilizacion (color_mensaje);
end;

 {************************************************************}

 begin   {del programa principal}
  tray_archivo:= 'd:\ahorcado\palabras.lst';
  if existe_archivo (tray_archivo)
    then
     begin
      assign (arch_palabras, tray_archivo);
      reset(arch_palabras);
      codigo_tecla:=0;
      ocultar_cursor;
      while (codigo_tecla <> tecla_escape)
            do
             begin
              obten_palabra (arch_palabras, pal_adivinar.palabra);
              for i:= 1 to 12
                  do
                   pal_adivinar.aciertos[i]:= false;
              inicia_lista_letras (lista_letras);
              modo_grafico;
              inicio;
              seleccion_teclas (codigo_tecla, pal_adivinar);
              closegraph;
             end;
      close (arch_palabras);
     end
    else
     writeln('programa finalizado. el archivo ', tray_archivo, ' no encontrado');
end.
