/***************************************
* Agustn Guilln / Solo Programadores *
* Partes de David Welch                *
***************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>

#include "sb.h"

#define USHORT unsigned short

typedef struct
{
    char name[20];
    unsigned short off;
    unsigned short ver;
    unsigned short id;
} CABECERAVOC;

char gstring[80];
unsigned char ca;
unsigned short ra;
unsigned long la;
FILE *fp;

CABECERAVOC v;
char dtype;
unsigned long dlen;
unsigned char tc;
unsigned char pt;
unsigned char md;
unsigned char min;
unsigned char max;
unsigned long length;

void main ( int argc, char *argv[] )
{
    if(argc==1)
    {
        printf("Especifique un fichero VOC\n");
        exit(1);
    }
    strcpy(gstring,argv[1]);
    strcat(gstring,".VOC");
    if((fp=fopen(gstring,"rb"))==NULL)
    {
        strcpy(gstring,argv[1]);
        if((fp=fopen(gstring,"rb"))==NULL)
        {
            printf("No encuentro el fichero VOC [%s]\n",argv[1]);
            exit(1);
        }
    }
    printf("Fichero:  [%s]\n",gstring);
    sbsetup();
    fread(&v,1,sizeof(CABECERAVOC),fp);
    for(ra=0;ra<19;ra++) gstring[ra]=v.name[ra]; gstring[ra]=0;
    if((strcmp(gstring,"Creative Voice File")!=0)||(v.name[ra]!=0x1A))
    {
        printf("Este fichero no es un Creative Voice File\n");
        exit(1);
    }
    printf("Creative Voice File  V%u.%02u\n",(v.ver>>8)&0xFF,v.ver&0xFF);
    printf("Los datos empiezan en el offset %08Xh\n",v.off);
    printf("Cdigo de identificacin VOC %04Xh, ",v.id);
    if((((~v.ver)+0x1234)&0xFFFF)==v.id) printf("OK\n");
    else { printf("Algo fallo...\n"); exit(1); }
    while(1)
    {
        if(fread(&dtype,1,1,fp)==0) break;
        dlen=0; fread(&dlen,1,3,fp);
        printf("\nTipo de bloque %u:  ",(USHORT)dtype);
        if(dtype==0)
        {
            printf("Terminador\n");
            break;
        }
        if(dtype==1)
        {
            printf("Datos de sonido\n");
            printf("Longitud del bloque %lu\n",dlen);
            fread(&tc,1,1,fp);
            printf("Velocidad de muestreo %u, ",(USHORT)tc);
            ra=1000000L/(256L-tc);
            printf("%u Hz\n",ra);
            fread(&pt,1,1,fp);
            printf("Tipo de compresin %u:  ",(USHORT)pt);
            switch(pt)
            {
                case 0: printf("8 bits sin compresin\n"); break;
                case 1: printf("Compresin 4 bits\n"); break;
                case 2: printf("Compresin 2.6 bits\n"); break;
                case 3: printf("Compresin 2 bits \n"); break;
                case 4: printf("1 canal multi\n"); break;
                case 5: printf("2 canales multi\n"); break;
                case 6: printf("3 canales multi\n"); break;
                case 7: printf("4 canales multi\n"); break;
                case 8: printf("5 canales multi\n"); break;
                case 9: printf("6 canales multi\n"); break;
                case 10: printf("7 canales multi\n"); break;
                default: printf("No se lo que es...\n"); break;
            }
            if(pt==0)
            {
                sbsettc(tc);
                spkon();
                length=dlen-2;
                while(length)
                {
                    if(length>65000) la=65000; else la=length;
                    length-=la;
                    fread(aligned,1,la,fp);
                    sbplay(la);
                    printf("%lu Samples\n",la);
                    while(dmacount()!=0xFFFF)
                    {
                        if(kbhit())
                        {
                            sbhaltdma();
                            getch();
                            spkoff();
                            exit(0);
                        }
                    }
                }
                spkoff();
            }
            else
            {
                printf("Tipo de compresin invlido\n");
                fseek(fp,ftell(fp)+dlen-2,0);
            }
        }
        if(dtype==2)
        {
            printf("Continuacin de Datos de sonido\n");
            printf("Longitud del bloque %lu\n",dlen);
            max=0x00;
            min=0xFF;
            for(la=0;la<dlen;la++)
            {
                fread(&ca,1,1,fp);
                if(ca>max) max=ca;
                if(ca<min) min=ca;
            }
            printf("Mximo %u, Mnimo %u\n",(USHORT)max,(USHORT)min);
        }
        if(dtype==3)
        {
            printf("Silencio\n");
            printf("Longitud del bloque %lu\n",dlen);
            fread(&ra,1,2,fp);
            printf("Periodo %u\n",ra);
            fread(&tc,1,1,fp);
            printf("Velocidad de muestreo %u, ",(USHORT)tc);
            ra=1000000L/(256L-tc);
            printf("%u Hz\n",ra);
        }
        if(dtype==4)
        {
            printf("Marcador");
            printf("Longitud del bloque %lu\n",dlen);
            fread(&ra,1,2,fp);
            printf("Valor del Marcador %u, %04Xh\n",ra,ra);
            if(dlen>2) fseek(fp,ftell(fp)+dlen-2,0);
        }
        if(dtype==5)
        {
            printf("Texto ASCII\n");
            printf("Longitud del bloque %lu\n",dlen);
            la=dlen;
            while(la)
            {
                if(la>79) ca=79; else ca=la;
                la-=ca;
                fread(gstring,1,ca,fp); gstring[79]=0;
                printf("%s",gstring);
            }
        }
        if(dtype==6)
        {
            printf("Bucle de repeticin\n");
            printf("Longitud del bloque %lu\n",dlen);
            fread(&ra,1,2,fp);
            printf("Contador %u\n",ra);
        }
        if(dtype==7)
        {
            printf("Fin del Bluque de repeticin\n");
            printf("Longitud del bloque %lu\n",dlen);
        }
        if(dtype==8)
        {
            printf("Bloque extendido\n");
            printf("Longitud del bloque %lu\n",dlen);
            fread(&ra,1,2,fp);
            printf("Velocidad de muestreo %u, ",ra);
            ra=256000000L/(65536L-ra);
            printf("%u Hz\n",ra);
            fread(&pt,1,1,fp);
            printf("Tipo de compresin %u:  ",(USHORT)pt);
            switch(pt)
            {
                case 0: printf("8 bits sin compresin\n"); break;
                case 1: printf("Compresin 4 bits\n"); break;
                case 2: printf("Compresin 2.6 bits\n"); break;
                case 3: printf("Compresin 2 bits \n"); break;
                case 4: printf("1 canal multi\n"); break;
                case 5: printf("2 canales multi\n"); break;
                case 6: printf("3 canales multi\n"); break;
                case 7: printf("4 canales multi\n"); break;
                case 8: printf("5 canales multi\n"); break;
                case 9: printf("6 canales multi\n"); break;
                case 10: printf("7 canales multi\n"); break;
                default: printf("No se lo que es...\n"); break;
            }
            fread(&md,1,1,fp);
            printf("Modo %u, ",(USHORT)md);
            switch(md)
            {
                case 0: printf("mono\n"); break;
                case 1: printf("estreo\n"); break;
                default: printf("desconocido\n"); break;
            }
        }
        if(dtype>8)
        {
            printf("Bloque Desconocido\n");
            printf("Longitud del bloque %lu\n",dlen);
            fseek(fp,ftell(fp)+dlen,0);
        }
    }
}

